unit Visapp;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs;

type
  TVisualApplication = class(TComponent)
  private
    { Private declarations }
		FOnActivate: TNotifyEvent;
		FOnDeactivate: TNotifyEvent;
		FOnException: TExceptionEvent;
		FOnHelp: THelpEvent;
		FOnHint: TNotifyEvent;
		FOnIdle: TIdleEvent;
		FOnMessage: TMessageEvent;
		FOnMinimize: TNotifyEvent;
		FOnRestore: TNotifyEvent;
		FOnShowHint: TShowHintEvent;
	protected
		{ Protected declarations }
		function GetOnActivate: TNotifyEvent;
		procedure SetOnActivate(AOnActivate: TNotifyEvent);
		function GetOnDeactivate: TNotifyEvent;
		procedure SetOnDeactivate(AOnDeactivate: TNotifyEvent);
		function GetOnException: TExceptionEvent;
		procedure SetOnException(AOnException: TExceptionEvent);
		function GetOnHelp: THelpEvent;
		procedure SetOnHelp(AOnHelp: THelpEvent);
		function GetOnHint: TNotifyEvent;
		procedure SetOnHint(AOnHint: TNotifyEvent);
		function GetOnIdle: TIdleEvent;
		procedure SetOnIdle(AOnIdle: TIdleEvent);
		function GetOnMessage: TMessageEvent;
		procedure SetOnMessage(AOnMessage: TMessageEvent);
		function GetOnMinimize: TNotifyEvent;
		procedure SetOnMinimize(AOnMinimize: TNotifyEvent);
		function GetOnRestore: TNotifyEvent;
		procedure SetOnRestore(AOnRestore: TNotifyEvent);
		function GetOnShowHint: TShowHintEvent;
		procedure SetOnShowHint(AOnShowHint: TShowHintEvent);
	public
		{ Public declarations }
		constructor Create(AOwner: TComponent); override;
	published
		{ Published declarations }
		property OnActivate: TNotifyEvent read GetOnActivate write SetOnActivate;
		property OnDeactivate: TNotifyEvent read GetOnDeactivate write SetOnDeactivate;
		property OnException: TExceptionEvent read GetOnException write SetOnException;
		property OnHelp: THelpEvent read GetOnHelp write SetOnHelp;
		property OnHint: TNotifyEvent read GetOnHint write SetOnHint;
		property OnIdle: TIdleEvent read GetOnIdle write SetOnIdle;
		property OnMessage: TMessageEvent read GetOnMessage write SetOnMessage;
		property OnMinimize: TNotifyEvent read GetOnMinimize write SetOnMinimize;
		property OnRestore: TNotifyEvent read GetOnRestore write SetOnRestore;
		property OnShowHint: TShowHintEvent read GetOnShowHint write SetOnShowHint;
	end;

procedure Register;

implementation

{TVisualApplication}
constructor TVisualApplication.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
end;

function TVisualApplication.GetOnActivate: TNotifyEvent;
begin
	if csDesigning in ComponentState then result := FOnActivate
	else result := Application.OnActivate;
end;

procedure TVisualApplication.SetOnActivate(AOnActivate: TNotifyEvent);
begin
	if csDesigning in ComponentState then FOnActivate := AOnActivate
	else Application.OnActivate := AOnActivate;
end;

function TVisualApplication.GetOnDeactivate: TNotifyEvent;
begin
	if csDesigning in ComponentState then result := FOnDeactivate
	else result := Application.OnDeactivate;
end;

procedure TVisualApplication.SetOnDeactivate(AOnDeactivate: TNotifyEvent);
begin
	if csDesigning in ComponentState then FOnDeactivate := AOnDeactivate
	else Application.OnDeactivate := AOnDeactivate;
end;

function TVisualApplication.GetOnException: TExceptionEvent;
begin
	if csDesigning in ComponentState then result := FOnException
	else result := Application.OnException;
end;

procedure TVisualApplication.SetOnException(AOnException: TExceptionEvent);
begin
	if csDesigning in ComponentState then FOnException := AOnException
	else Application.OnException := AOnException;
end;

function TVisualApplication.GetOnHelp: THelpEvent;
begin
	if csDesigning in ComponentState then result := FOnHelp
	else result := Application.OnHelp;
end;

procedure TVisualApplication.SetOnHelp(AOnHelp: THelpEvent);
begin
	if csDesigning in ComponentState then FOnHelp := AOnHelp
	else Application.OnHelp := AOnHelp;
end;

function TVisualApplication.GetOnHint: TNotifyEvent;
begin
	if csDesigning in ComponentState then result := FOnHint
	else result := Application.OnHint;
end;

procedure TVisualApplication.SetOnHint(AOnHint: TNotifyEvent);
begin
	if csDesigning in ComponentState then FOnHint := AOnHint
	else Application.OnHint := AOnHint;
end;

function TVisualApplication.GetOnIdle: TIdleEvent;
begin
	if csDesigning in ComponentState then result := FOnIdle
	else result := Application.OnIdle;
end;

procedure TVisualApplication.SetOnIdle(AOnIdle: TIdleEvent);
begin
	if csDesigning in ComponentState then FOnIdle := AOnIdle
	else Application.OnIdle := AOnIdle;
end;

function TVisualApplication.GetOnMessage: TMessageEvent;
begin
	if csDesigning in ComponentState then result := FOnMessage
	else result := Application.OnMessage;
end;

procedure TVisualApplication.SetOnMessage(AOnMessage: TMessageEvent);
begin
	if csDesigning in ComponentState then FOnMessage := AOnMessage
	else Application.OnMessage := AOnMessage;
end;

function TVisualApplication.GetOnMinimize: TNotifyEvent;
begin
	if csDesigning in ComponentState then result := FOnMinimize
	else result := Application.OnMinimize;
end;

procedure TVisualApplication.SetOnMinimize(AOnMinimize: TNotifyEvent);
begin
	if csDesigning in ComponentState then FOnMinimize := AOnMinimize
	else Application.OnMinimize := AOnMinimize;
end;

function TVisualApplication.GetOnRestore: TNotifyEvent;
begin
	if csDesigning in ComponentState then result := FOnRestore
	else result := Application.OnRestore;
end;

procedure TVisualApplication.SetOnRestore(AOnRestore: TNotifyEvent);
begin
	if csDesigning in ComponentState then OnRestore := AOnRestore
	else Application.OnRestore := AOnRestore;
end;

function TVisualApplication.GetOnShowHint: TShowHintEvent;
begin
	if csDesigning in ComponentState then result := FOnShowHint
	else result := Application.OnShowHint;
end;

procedure TVisualApplication.SetOnShowHint(AOnShowHint: TShowHintEvent);
begin
	if csDesigning in ComponentState then FOnShowHint := AOnShowHint
	else Application.OnShowHint := AOnShowHint;
end;

procedure Register;
begin
	RegisterComponents('System', [TVisualApplication]);
end;

end.
